The Morning Star

题目描述

本题有多组数据。

给定 n 个点,第 i 个点的坐标为 xi​,yi​。

现需要将星星和指南针放在任意两个点上,使得星星在指南针的正北、正东、正西、正南、正东南、正东北、正西南或正西北方向,求一共几种放法。(如果对此不太理解结合样例解释)

输入格式

第一行输入一个t,表示数据组数。

在每组数据中,输入n,表示点的总数。

接下来 n 行,第i行输入两个数 xi​,yi​,表示第i个点的坐标。

输出格式

输出共t行,每行一个整数,表示第i组数据的结果。

提示

在第一组数据中:

指南针在 (0,0)(0,0),星星在 (−1,−1)(−1,−1),在指南针的正西南方向。

指南针在 (0,0)(0,0),星星在 (1,1)(1,1),在指南针的正东北方向。

指南针在 (−1,−1)(−1,−1),星星在 (0,0)(0,0),在指南针的正东北方向。

指南针在(−1,−1)(−1,−1),星星在(1,1)(1,1),在指南针的正东北方向。

指南针在(1,1)(1,1),星星在(0,0)(0,0),在指南针的正西南方向。

指南针在(1,1)(1,1),星星在(−1,−1)(−1,−1),在指南针的正西南方向。

所以答案为6。

在第二组数据中:

指南针在(6,9)(6,9),星星在(10,13)(10,13),在指南针的正东北方向。

指南针在(10,13)(10,13),星星在(6,9)(6,9),在指南针的正西南方向。

所以答案是 2。

参考代码

cpp 复制代码
#include <bits/stdc++.h>
#define ll long long
using namespace std;

ll x[200005], y[200005];

bool Z(ll x1, ll y1, ll x2, ll y2)
{
	return (abs(x1 - x2) == abs(y1 - y2)) ? true : false;
}

bool north(int z, int star)
{
	return (x[z] == x[star] && y[z] < y[star]) ? true : false;
}

bool south(int z, int star)
{
	return (x[z] == x[star] && y[z] > y[star]) ? true : false;
}

bool west(int z, int star)
{
	return (y[z] == y[star] && x[z] > x[star]) ? true : false;
}

bool east(int z, int star)
{
	return (y[z] == y[star] && x[z] < x[star]) ? true : false;
}

bool eastsouth(int z, int star)
{
	return (Z(x[z], y[z], x[star], y[star]) && x[z] < x[star] && y[z] > y[star]) ? true : false;
}

bool eastnorth(int z, int star)
{
	return (Z(x[z], y[z], x[star], y[star])  && x[z] < x[star] && y[z] < y[star]) ? true : false;
}

bool westsouth(int z, int star)
{
	return (Z(x[z], y[z], x[star], y[star])  && x[z] > x[star] && y[z] > y[star]) ? true : false;
}

bool westnorth(int z, int star)
{
	return (Z(x[z], y[z], x[star], y[star])  && x[z] > x[star] && y[z] < y[star]) ? true : false;
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	
	int t;
	cin>>t;
	
	while(t--)
	{
		int n, ans = 0;
		
		cin>>n;
		
		for(int i = 1; i <= n; i++)
			cin>>x[i]>>y[i];
		
		for(int i = 1; i <= n; i++)
		{
			for(int j = 1; j <= n; j++)
			{
				if(i == j)
					continue;
					
				if(north(i, j) || south(i, j) || west(i, j) || east(i, j))
					ans++;
				else if(eastnorth(i, j) || eastsouth(i, j) || westnorth(i, j) || westsouth(i, j))
					ans++;
			}
		}
		
		cout<<ans<<"\n";
	}
	
	
	return 0;
}
相关推荐
Logic10112 分钟前
C语言/数据结构组合数学题解:数字好排列计数——质数倍数分类与阶乘取模
c语言·数据结构·算法·组合数学·时间复杂度·排列·取模运算
碧海银沙音频科技研究院32 分钟前
炬芯ATS3089智能手表烧录方法
人工智能·驱动开发·嵌入式硬件·算法
INGNIGHT35 分钟前
486. 预测赢家(博弈dp/区间dp)
linux·c++
维克兜率天36 分钟前
【维克】统计套利:寻找市场的“定价误差“
人工智能·python·算法
aqiu1111111 小时前
【C++算法打怪专栏】LeetCode 1. 两数之和(哈希表解法总结)
c++·算法·leetcode
楚识科技1 小时前
票据 OCR 识别技术深度解析:从算法原理到企业级落地实现
算法·ocr
longlongzihan1 小时前
LeetCode 25. K 个一组翻转链表 (迭代+分组反转法)
算法·leetcode·链表
xuxigifxfh1 小时前
牛客:BISHI8 大整数哈希
java·算法·哈希算法
涉密IT资质笔记1 小时前
涉密资质投入产出分析模型:时间成本、四块成本构成与 ROI 决策框架
java·开发语言·算法
木井巳1 小时前
【BFS 解决拓扑排序】火星词典
java·算法·leetcode·广度优先·宽度优先·图搜索算法